#include "Grass.h"

#include "Game.h"
#include "ItemEntity.h"

GrassBlock::GrassBlock(int typeId, Framework::Vec3<int> pos, int dimensionId)
    : AdditionalItemSpawningBlock(typeId, pos, dimensionId)
{
    transparent = 1;
}

bool GrassBlock::onTick(TickQueue* zQueue, int numTicks, bool& blocked)
{
    // TODO: spread to neighbor blocks if light level is hight enought
    return 0;
}

void GrassBlock::onPostTick() {}

void GrassBlock::filterPassingLight(unsigned char rgb[3]) const
{
    rgb[0] = (unsigned char)(rgb[0] * 0.7);
    rgb[1] = (unsigned char)(rgb[1] * 0.9);
    rgb[2] = (unsigned char)(rgb[2] * 0.7);
}

TickSourceType GrassBlock::isTickSource() const
{
    return TickSourceType::EACH_TICK;
}

GrassBlockType::GrassBlockType()
    : AdditionalItemSpawningBlockType()
{}

ItemType* GrassBlockType::createItemType() const
{
    return 0;
}

void GrassBlockType::createSuperBlock(Block* zBlock, Item* zItem) const
{
    AdditionalItemSpawningBlockType::createSuperBlock(zBlock, zItem);
}

void GrassBlockType::loadSuperBlock(
    Block* zBlock, Framework::StreamReader* zReader, int dimensionId) const
{
    AdditionalItemSpawningBlockType::loadSuperBlock(
        zBlock, zReader, dimensionId);
}

void GrassBlockType::saveSuperBlock(
    Block* zBlock, Framework::StreamWriter* zWriter) const
{
    AdditionalItemSpawningBlockType::saveSuperBlock(zBlock, zWriter);
}

Item* GrassBlockType::createItem() const
{
    return 0;
}

Block* GrassBlockType::createBlock(
    Framework::Vec3<int> position, int dimensionId) const
{
    return new GrassBlock(getId(), position, dimensionId);
}

GrassBlockTypeFactory::GrassBlockTypeFactory()
    : AdditionalItemSpawningBlockTypeFactory()
{}

BasicBlockType* GrassBlockTypeFactory::createValue(
    Framework::JSON::JSONObject* zJson) const
{
    return new GrassBlockType();
}

BasicBlockType* GrassBlockTypeFactory::fromJson(
    Framework::JSON::JSONObject* zJson) const
{
    return AdditionalItemSpawningBlockTypeFactory::fromJson(zJson);
}

Framework::JSON::JSONObject* GrassBlockTypeFactory::toJsonObject(
    BasicBlockType* zObject) const
{
    return AdditionalItemSpawningBlockTypeFactory::toJsonObject(zObject);
}

JSONObjectValidationBuilder* GrassBlockTypeFactory::addToValidator(
    JSONObjectValidationBuilder* builder) const
{
    return AdditionalItemSpawningBlockTypeFactory::addToValidator(builder);
}

const char* GrassBlockTypeFactory::getTypeToken() const
{
    return "grass";
}

const char* GrassBlockTypeFactory::getTypeName() const
{
    return typeid(GrassBlockType).name();
}
