#include "ItemSkill.h"

#include "Block.h"
#include "Entity.h"
#include "ItemType.h"

ItemSkill::ItemSkill()
    : Framework::ReferenceCounter(),
      xp(10.f),
      maxXP(10.f),
      level(1.f),
      itemTypeId(-1)
{}

void ItemSkill::load(Framework::StreamReader* zReader)
{
    zReader->lese((char*)&xp, 4);
    zReader->lese((char*)&maxXP, 4);
    zReader->lese((char*)&level, 4);
    zReader->lese((char*)&itemTypeId, 4);
}

void ItemSkill::save(Framework::StreamWriter* zWriter)
{
    zWriter->schreibe((char*)&xp, 4);
    zWriter->schreibe((char*)&maxXP, 4);
    zWriter->schreibe((char*)&level, 4);
    zWriter->schreibe((char*)&itemTypeId, 4);
}

bool ItemSkill::interact(Entity* zActor, Item* zUsedItem, Block* zTarget)
{
    return zTarget->interact(zUsedItem, zActor);
}

bool ItemSkill::interact(Entity* zActor, Item* zUsedItem, Entity* zTarget)
{
    return zTarget->interact(zUsedItem, zActor);
}

void ItemSkill::setXp(float xp)
{
    this->xp = xp;
}

float ItemSkill::getXp() const
{
    return xp;
}

void ItemSkill::setMaxXp(float maxXp)
{
    this->maxXP = maxXp;
}

float ItemSkill::getMaxXp() const
{
    return maxXP;
}

void ItemSkill::setLevel(float level)
{
    this->level = level;
}

float ItemSkill::getLevel() const
{
    return level;
}

void ItemSkill::setItemTypeId(int itemTypeId)
{
    this->itemTypeId = itemTypeId;
}

int ItemSkill::getItemTypeId() const
{
    return itemTypeId;
}