#include "MultiplyNoise.h"

MultiplyNoise::MultiplyNoise(Noise* base, Noise* multiplier)
    : Noise(),
      base(base),
      multiplier(multiplier)
{}

MultiplyNoise::~MultiplyNoise()
{
    base->release();
    multiplier->release();
}

int MultiplyNoise::getSeed() const
{
    return base->getSeed();
}

double MultiplyNoise::getNoise(double x, double y, double z)
{
    return base->getNoise(x, y, z)
                   * multiplier->getNoise(x, y, z);
}